#!/pfrm2.0/bin/lua 

--[[
#### sen
#### jan13, 2011

#### File: hardwareNat.lua
#### Description: enable/disable sppe based on followinf conditions-
                  1. Content filtering is enabled/disabled
                  2. BwProfiles is enabled/disabled
                  3. IPS is enabled/disabled

#### Revisions:
#### dec13,2012 su removed bwprof, netQos from limitations list.
#### jun8,2011 kmk Added IPS check
None
]]--


--************* Requires *************
require "teamf1lualib/util"
require "teamf1lualib/db"

--************* Initial Code *************

--************* Logic *************

db.connect(arg[1])
local bwRow = {}
local wan1TraffRow = {}
local wan2TraffRow = {}
local wan3TraffRow = {}
local wan4TraffRow = {}
local netQosRow = {}
local lanTraffTable = {}
local contentRow = {}

bwRow = db.getRow("BandWidthProfileStatus", "_ROWID_", "1")
wan1TraffRow = db.getRow("FwTrafficMeter","WanId","1")
wan2TraffRow = db.getRow("FwTrafficMeter","WanId","2")
wan3TraffRow = db.getRow("FwTrafficMeter","WanId","3")
wan4TraffRow = db.getRow("FwTrafficMeter","WanId","4")
netQosRow = db.getRow("NetworkQos", "_ROWID_", "1")
lanTraffTable = db.tableSize("FwTrafficMeterLan")
contentRow = db.getRow("ContentFiltering","_ROWID_","1")

local procEntry = db.getAttribute("environment", "name", "HW_OFFLOAD_PROC_ENTRY", "value")

if ((wan1TraffRow["FwTrafficMeter.TrafficMeterStatus"] == "1") or
    (wan2TraffRow["FwTrafficMeter.TrafficMeterStatus"] == "1") or
    (wan3TraffRow["FwTrafficMeter.TrafficMeterStatus"] == "1") or
    (wan4TraffRow["FwTrafficMeter.TrafficMeterStatus"] == "1") or
    (lanTraffTable ~= "0")
    ) then
    print("Disable hardware offload")
    os.execute("echo 0 >" .. procEntry)

else
    print("Enable hardwareoffload")
    os.execute("echo 1 >" .. procEntry)
end
