--[[
#### Hussain Vali.
#### TeamF1
#### www.TeamF1.com
#### Mar 14, 2008
#### File: nimf.lua
#### Description: NIMF Setup functions
#### Revisions:
01a 05Aug11, Smita P. Added nimf.secConfig () function
]]--

--************* Requires *************

--************* Initial Code *************

--package NIMF Configurations
nimf = {}

--************* Functions *************
-- Network Interface Management Framework(NIMF) config
function nimf.config (inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then
            return db.update("NimfConf", inputTable, rowid)
        elseif (operation == "delete") then
            return nil
        end
    end
    return false
end

-- Config function that operates on the table provided 
function nimf.secConfig (inputTable, rowid, operation, tableName)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return db.insert(tableName, inputTable)
        elseif (operation == "edit") then
            return db.update(tableName, inputTable, rowid)
        elseif (operation == "delete") then
            return db.delete(tableName,inputTable)
        end
	end    
	return false
end
