--[[
#### Chaitanya Garrepalli.
#### TeamF1
#### www.TeamF1.com
#### Aug 29, 2012
#### File: ping.lua
#### Revisions:
01b,30nov12,ksr fix spr 35880
01a,28aug12,cg  written
]]--

--************* Requires *************
require "pingLib"
require "teamf1lualib/ifDev"
--************* Initial Code *************

--package Configuration
ping = {}

function ping.pingAddress (inputTable)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end
    local errStr
    if (string.find(inputTable["ping.pingAddress"],":")) then
        local ipAddrRows = db.getRowsWhere ("ipAddressTable","addressFamily = 10 AND LogicalIfName = 'LAN'" )
        if(#ipAddrRows ~= 0)then
            local i = 0
			for k,v in pairs (ipAddrRows) do
                i = i + 1
                local row = ipAddrRows[i]
                local status = ifDev.twoIPv6AddressInSameSubnet(inputTable["ping.pingAddress"], row["ipAddressTable.ipAddress"],row["ipAddressTable.ipv6PrefixLen"])
                if (status == "OK") then
                    inputTable["ping.localGw"] = "LAN"
                end
            end
        end
    end


    errStr = pingLib.pingStart (inputTable["ping.addressFamily"], inputTable["ping.throughVpn"], inputTable["ping.vpnName"], inputTable["ping.localGw"], inputTable["ping.pingAddress"])

    if errStr == 'OK' then
        return "OK", "STATUS_OK"
    else 
        return "ERROR", errStr
    end

end

