--[[
#### .
#### TeamF1
#### www.TeamF1.com
#### 13 jun , 2012
#### File: siitCLI.lua
#### Description: SIIT Setup functions
#### Revisions:
01a 13jun12, akr written 
]]--

--************* Requires *************
require "teamf1lualib/siitView"


--function for SIIT conf initialization
function siitCfgInit(args)
	local configRow = {}
	configRow = db.getRow("siitTbl", "rowid", "1")
	if (configRow == nil) then
		-- default values
		configRow["siitTbl.enable"] = '0'	
		configRow["siitTbl.ipAddr"] = '0.0.0.0'	
	end
	return 1,configRow 
end
--function for SIIT conf input validation 
function siitCfgInputVal(configRow)
	if(configRow ~= nil) then
		if(configRow["siitTbl.enable"] == nil or configRow["siitTbl.enable"] == '')then
			printCLIError('Please select option for enabling or disabling SIIT.')
			return false
		end
        if(configRow["siitTbl.enable"] == "1")then
            if(configRow["siitTbl.ipAddr"] == nil or configRow["siitTbl.ipAddr"] == "" or  configRow["siitTbl.ipAddr"] == "0.0.0.0") then
			    printCLIError('Please enter valid IPv4 address.')
			    return false
            end
		end
	end
	return true
end
--function for SIIT conf save
function siitCfgSave(configRow)
	local errorFlag = 'OK'
	errorFlag, statusCode = siitView.siitConfigSet(configRow, "1", "edit")	
	-- save db if no error
	if (errorFlag == "OK") then db.save() end
        return errorFlag
end


--function for showing SIIT configuration 
function siitCfgGet(args)
	local configRow = {}
	local siitEnable = 'disabled'
	local siitIpAddr = '0.0.0.0'
	configRow = db.getRow("siitTbl", "rowid", "1")
	if (configRow ~= nil) then
		if(configRow["siitTbl.enable"] == '1')then
			siitEnable = 'enabled'
		elseif(configRow["siitTbl.enable"] == '0')then
			siitEnable = 'disabled'
		end
		if(configRow["siitTbl.ipAddr"] ~= '' and configRow["siitTbl.ipAddr"] ~= nil )then
			siitIpAddr = configRow["siitTbl.ipAddr"]
		end
	end
	printLabel("SIIT Configuraton")	
	print("Status      ",siitEnable or '')
	print("IPv4 Address",siitIpAddr or '')
	return true
end
