--[[
#### Sat
#### TeamF1
#### www.TeamF1.com
#### Jan 22, 2008

#### File: tcpdump.lua
#### Description: tcpdump functions
#### modification history
#01a,06apr12,sig fixed for spr#22654
#### Revisions:
None
]]--


--************* Requires *************

--************* Initial Code *************
--package tcpdump
tcpdump = {}

--************* Functions *************
-- tcpdump config
function tcpdump.config (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
        return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
    local valid = false

    if (inputTable ["tcpdump.tcpdumpEnabled"] == "1" ) then
        local ifStatus = db.getAttribute ("networkInterface", "LogicalIfName",inputTable["tcpdump.LogicalIfName"], "IfStatus")
        if (ifStatus == "0") then
            db.rollback()
            return "ERROR", "TCPDUMP_IFACE_DOWN"
        end
    end            
    -- validate
    if (true) then
        if (operation == "add") then
            return nil
        elseif (operation == "edit") then
            valid = tcpdump.update_config(inputTable,rowid)
        elseif (operation == "delete") then
            return nil
        end
    end

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "TCPDUMP_CONFIG_FAILED"
    end
end

-- Updating Configurations
function tcpdump.update_config (inputTable,rowid)
    -- updating TCPDUMP Configurations
    valid = db.update("tcpdump",inputTable,rowid)
    return valid
end

