-- trafficMeterCLI.lua
-- Samer Sayeed
-- TeamF1
-- www.TeamF1.com
--
-- Modification History
-- 23jan12,akr 23938 
-- 29jan09,ss did code cleanup 
-- 07jan09,ss written 
--
-- Description
-- CLI interface set and get routines

require "teamf1lualib/fwView"

totalLimit = ""

function trafficMeterCfgSave(configRow)
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "FwTrafficMeter"

    errorFlag, statusCode = fwView.trafficMeterConfig(configRow, configRow["FwTrafficMeter._ROWID_"], "edit")
    
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    fwView.hwOffloadUpdate()
    return errorFlag, statusMessage
end

function trafficMeterCfgInit(args)
    configRow = db.getRow("FwTrafficMeter","WanId", args[1])
    if(tonumber(configRow["FwTrafficMeter.TimeHH"]) > 12 and tonumber(configRow["FwTrafficMeter.TimeHH"]) <=23) then 
	    configRow["FwTrafficMeter.spHour"] = tonumber(configRow["FwTrafficMeter.TimeHH"]) - 12
    end
    if(tonumber(configRow["FwTrafficMeter.TimeHH"]) == 0) then
		configRow["FwTrafficMeter.spHour"] = "12"
    end

    if (configRow == nil) then
        configRow = {}
    elseif (configRow["FwTrafficMeter.TrafficMeterStatus"] == "1" and configRow["FwTrafficMeter.TrafficLimitType"] ~= "0") then
        if (configRow["FwTrafficMeter.IncreaseLimitStatus"] == "1") then
            totalLimit = tonumber (configRow["FwTrafficMeter.TrafficMonthlyLimit"]) + tonumber (configRow["FwTrafficMeter.IncreaseLimitBy"])
        else
            totalLimit = configRow["FwTrafficMeter.TrafficMonthlyLimit"]
        end
    end
    return configRow["FwTrafficMeter._ROWID_"], configRow
end

function trafficMeterCfgInputVal(configRow)
	if (configRow["FwTrafficMeter.TrafficMeterStatus"] == "1") then
	    if(configRow["FwTrafficMeter.RestartCounter"] == "1")then
		if (configRow["FwTrafficMeter.spHour"] ~= nil) then
			if (tonumber(configRow["FwTrafficMeter.spHour"]) < 1 or tonumber(configRow["FwTrafficMeter.spHour"]) > 12) then
				printCLIError("Invalid hour,Please enter hour between 1 to 12")
				return false
			end
		else
			printCLIError("Invalid Hour, Please enter value.")
			return false
		end
	    end
	end
    if(configRow["FwTrafficMeter.TrafficMeterStatus"] == 1 and configRow["FwTrafficMeter.TrafficLimitType"] == "0") then
    print("Traffic Meter is now in 'No Limit' Mode. Traffic Limit changes are not effective in this mode")
    end    
    return true
end

function trafficMeterSetupGet(args)
    local resultTab = {}

    tmRow = db.getRow("FwTrafficMeter","WanId", args[1])
    if(tmRow == nil) then 
        print("Traffic Meter configurations unavailable\n")
    else
       -- printLabel("Enable Traffic Meter")
        if(tmRow["FwTrafficMeter.TrafficMeterStatus"] == "0") then
            print("Traffic Meter is Disabled\n") 
        elseif(tmRow["FwTrafficMeter.TrafficMeterStatus"] == "1") then
            print("Traffic Meter is Enabled\n")
            if(tmRow["FwTrafficMeter.TrafficLimitType"] == "0")then limitType="No Limit"
            elseif(tmRow["FwTrafficMeter.TrafficLimitType"] == "1") then limitType="Download only"
            elseif(tmRow["FwTrafficMeter.TrafficLimitType"] == "2") then limitType="Both Directions"
            end
            print("Limit Type " .. limitType .. "\n") 	 
            print("Monthly Limit in (MB): " .. tmRow["FwTrafficMeter.TrafficMonthlyLimit"] .. "\n") 	

            if(tmRow["FwTrafficMeter.IncreaseLimitStatus"] == "1")then
                print("Increase this month limit: Enabled \n") 		 
                if(tmRow["FwTrafficMeter.IncreaseLimitBy"] ~= nil)then
                    print("Increase limit by in (MB): " .. tmRow["FwTrafficMeter.IncreaseLimitBy"] .. "\n") 	
                end
            else
                print("Increase this month limit: Disabled \n") 		 
            end
        if (tmRow["FwTrafficMeter.TrafficMeterStatus"] == "1" and tmRow["FwTrafficMeter.TrafficLimitType"] ~= "0") then
            if (tmRow["FwTrafficMeter.IncreaseLimitStatus"] == "1") then
            totalLimit = tonumber (tmRow["FwTrafficMeter.TrafficMonthlyLimit"]) + tonumber (tmRow["FwTrafficMeter.IncreaseLimitBy"])
        else
            totalLimit = tmRow["FwTrafficMeter.TrafficMonthlyLimit"]
        end
    end

            print("This month limit in (MB): " .. totalLimit .. "\n") 		 
            if (tonumber(tmRow["FwTrafficMeter.TimeHH"]) > 12 and tonumber(tmRow["FwTrafficMeter.TimeHH"]) < 23) then
                tmRow["FwTrafficMeter.spHour"] = tonumber(tmRow["FwTrafficMeter.TimeHH"]) - 12
                tmRow["FwTrafficMeter.startMeridian"] = "PM"
            elseif (tonumber(tmRow["FwTrafficMeter.TimeHH"]) == 12) then
                tmRow["FwTrafficMeter.spHour"] = tmRow["FwTrafficMeter.TimeHH"]
                tmRow["FwTrafficMeter.startMeridian"] = "PM"
            elseif (tonumber(tmRow["FwTrafficMeter.TimeHH"]) == 0) then
                tmRow["FwTrafficMeter.spHour"] = "12"
                tmRow["FwTrafficMeter.startMeridian"] = "AM"
            elseif (tonumber (tmRow["FwTrafficMeter.TimeHH"]) > 0 and tonumber (tmRow["FwTrafficMeter.TimeHH"]) <= 11) then
                tmRow["FwTrafficMeter.spHour"] = tmRow["FwTrafficMeter.TimeHH"]
                tmRow["FwTrafficMeter.startMeridian"] = "AM"
            end
            tmRow["FwTrafficMeter.spMinute"] = tmRow["FwTrafficMeter.TimeMM"]
            printLabel("Traffic Counter\n")
            if(tmRow["FwTrafficMeter.RestartCounter"] == "1")then
                print("Traffic Counter: Specific Time\n") 		 
            elseif((tmRow["FwTrafficMeter.RestartCounter"] == "0")) then 
                print("Traffic Counter: Restart Counter\n") 		 
            end
            if (tmRow["FwTrafficMeter.spHour"] ~= nil and tmRow["FwTrafficMeter.spMinute"] ~= nil and tmRow["FwTrafficMeter.DayOfMonth"] ~= nil) then
                print ("Restart Time (HH:MM-Day of Month): " .. tmRow["FwTrafficMeter.spHour"] .. ":" .. tmRow["FwTrafficMeter.spMinute"] .. " " .. tmRow["FwTrafficMeter.startMeridian"] .. " - " .. tmRow["FwTrafficMeter.DayOfMonth"])
            end
            if(tmRow["FwTrafficMeter.SendEmailReport"] == "1") then	 
                print("Send e-mail before restarting: Enabled\n")
            elseif (tmRow["FwTrafficMeter.SendEmailReport"] == "0") then		 
                print("Send e-mail before restarting: Disabled\n")
            end
            printLabel("When Limit is reached\n")
            if(tmRow["FwTrafficMeter.BlockTraffic"] == "0") then blockTraffic = "Block All Traffic"
            else blockTraffic = "Block All Traffic Except Email" end
            print("Traffic Block Status: " .. blockTraffic .." \n") 		 
            if(tmRow["FwTrafficMeter.SendEmailAlert"] == "1") then
                print("Send e-mail alert: Enabled\n")
            elseif (tmRow["FwTrafficMeter.SendEmailAlert"] == "0") then
                print("Send e-mail alert: Disabled\n")
            end
        end 
    end		 
    tsRow = db.getRow("TrafficStatistics", "WanId", args[1])
    if(tsRow ~= nil)then
        printLabel("Internet Traffic Statistics\n")
        resTab.insertField (resultTab, "Start Date / Time", tsRow["TrafficStatistics.StartTime"] or "")
        resTab.insertField (resultTab, "Outgoing Traffic Volume", tsRow["TrafficStatistics.OutgoingTrafVol"] or "")
        resTab.insertField (resultTab, "Incoming Traffic Volume", tsRow["TrafficStatistics.IncomingTrafVol"] or "")
        resTab.insertField (resultTab, "Average per day", tsRow["TrafficStatistics.AvgPerDay"] or "")
        resTab.insertField (resultTab, "% of Standard Limit", tsRow["TrafficStatistics.StandardLimit"] or "")
        resTab.insertField (resultTab, "% of this Month's Limit", tsRow["TrafficStatistics.ThisMonthLimit"] or "")
    end
    resTab.print (resultTab, 0)
end

function trafficMeterLanCfgSave(configRow)
    errorFlag = ""
    statusCode = ""
    statusMessage = ""
    DBTable = "FwTrafficMeterLan"

    if (configRow["FwTrafficMeterLan._ROWID_"] == "-1") then
	    errorFlag, statusCode = fwView.trafficMeterLanConfig(configRow, "-1", "add")
	else
        errorFlag, statusCode = fwView.trafficMeterLanConfig(configRow, configRow["FwTrafficMeterLan._ROWID_"], "edit")
    end
    
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
    print(statusMessage)
    fwView.hwOffloadUpdate()
    return errorFlag, statusMessage
end

function trafficMeterLanCfgInit(args)
    local configRow = {}
    configRow = db.getRow("FwTrafficMeterLan","LanIP", args[1])
    if (configRow ~= nil) then
        if(tonumber(configRow["FwTrafficMeterLan.TimeHH"]) > 12 and tonumber(configRow["FwTrafficMeterLan.TimeHH"]) <=23) then 
	        configRow["FwTrafficMeterLan.spHour"] = tonumber(configRow["FwTrafficMeterLan.TimeHH"]) - 12
            configRow["FwTrafficMeterLan.startMeridian"] = "1"
        end
        if(tonumber(configRow["FwTrafficMeterLan.TimeHH"]) > 0 and tonumber(configRow["FwTrafficMeterLan.TimeHH"]) <=11) then
            configRow["FwTrafficMeterLan.spHour"] = configRow["FwTrafficMeterLan.TimeHH"]
		    configRow["FwTrafficMeterLan.startMeridian"] = "0"
        end
        if(tonumber(configRow["FwTrafficMeterLan.TimeHH"]) == 0) then
		    configRow["FwTrafficMeterLan.spHour"] = "12"
		    configRow["FwTrafficMeterLan.startMeridian"] = "0"
        end
        if(tonumber(configRow["FwTrafficMeterLan.TimeHH"]) == 12) then
		    configRow["FwTrafficMeterLan.spHour"] = "12"
		    configRow["FwTrafficMeterLan.startMeridian"] = "1"
        end
        configRow["FwTrafficMeterLan.spMinute"] = configRow["FwTrafficMeterLan.TimeMM"]

        if (configRow == nil) then
            configRow = {}
        else
            totalLimit = configRow["FwTrafficMeterLan.TrafficMonthlyLimit"]
        end
    else
        configRow = {}
        configRow["FwTrafficMeterLan._ROWID_"] = "-1"
        configRow["FwTrafficMeterLan.LanIP"] = args[1]
        configRow["FwTrafficMeterLan.BlockTraffic"] = "1"
        configRow["FwTrafficMeterLan.SendEmailReport"] = "0"
        configRow["FwTrafficMeterLan.SendEmailAlert"] = "0"
    end
    return configRow["FwTrafficMeterLan._ROWID_"], configRow
end

function trafficMeterLanCfgInputVal(configRow)
    if (db.existsRowWhere("FwTrafficMeterLan","LanIP='"..configRow["FwTrafficMeterLan.LanIP"].."' AND _ROWID_!="..configRow["FwTrafficMeterLan._ROWID_"])) then
        printCLIError("This Lan IP address already exists.")
		return false
	end
    if(configRow["FwTrafficMeterLan.TrafficLimitType"] == "" or configRow["FwTrafficMeterLan.TrafficLimitType"] == nil)then
        printCLIError("Invalid direction type.")
		return false
	end
    if(configRow["FwTrafficMeterLan.TrafficMonthlyLimit"] == "" or configRow["FwTrafficMeterLan.TrafficMonthlyLimit"] == nil)then
        printCLIError("Invalid limit value.")
		return false
	end
    if(configRow["FwTrafficMeterLan.RestartCounter"] == "" or configRow["FwTrafficMeterLan.RestartCounter"] == nil)then
        printCLIError("Invalid Counter Restart type value.")
		return false
	end
	if(configRow["FwTrafficMeterLan.RestartCounter"] == "1")then
		if (configRow["FwTrafficMeterLan.spHour"] ~= nil and configRow["FwTrafficMeterLan.spHour"] ~= "") then
			if (tonumber(configRow["FwTrafficMeterLan.spHour"]) < 1 or tonumber(configRow["FwTrafficMeterLan.spHour"]) > 12) then
				printCLIError("Invalid hour,Please enter hour between 1 to 12")
				return false
			end
		else
			printCLIError("Invalid Hour, Please enter value.")
			return false
		end
        if(configRow["FwTrafficMeterLan.spMinute"] == "" or configRow["FwTrafficMeterLan.spMinute"] == nil)then
            printCLIError("Invalid Minute, Please enter value.")
		    return false
	    end
        if(configRow["FwTrafficMeterLan.startMeridian"] == "" or configRow["FwTrafficMeterLan.startMeridian"] == nil)then
            printCLIError("Invalid Meridian, Please enter value.")
		    return false
	    end
        if(configRow["FwTrafficMeterLan.DayOfMonth"] == "" or configRow["FwTrafficMeterLan.DayOfMonth"] == nil)then
            printCLIError("Invalid day_of_month, Please enter value.")
		    return false
	    end
	end
	
    return true
end

function trafficMeterLanCfgDel(args)
    local errorFlag = "ERROR"
    local statusCode = ""
    local statusMessage = ""
    DBTable = "FwTrafficMeterLan"
    
    configRow= db.getRow("FwTrafficMeterLan","_ROWID_",args[1])
    if (configRow == nil) then
		printCLIError("Row doesn't exist")
		return false
    end
    local rows = {}
    rows["rowid"] = configRow["FwTrafficMeterLan._ROWID_"]
    errorFlag, statusCode = fwView.trafficLanMeterDelete(rows)
    
    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
    fwView.hwOffloadUpdate()
    return errorFlag, statusMessage
end

function trafficMeterLanCfgGet(args)
    local resultTab = {}

    tmRow = db.getRow("FwTrafficMeterLan","_ROWID_", args[1])
    if(tmRow == nil) then 
        printCLIError("Row doesn't exist")
		return false
    else
            printLabel("LAN Traffic Meter Account")
            print("LAN IP Address: " .. tmRow["FwTrafficMeterLan.LanIP"] .. "\n")
            if(tmRow["FwTrafficMeterLan.TrafficLimitType"] == "1") then limitType="Download only"
            elseif(tmRow["FwTrafficMeterLan.TrafficLimitType"] == "2") then limitType="Both Directions"
            end
            print("Direction: " .. limitType .. "\n") 	 
            print("Limit in (MB): " .. tmRow["FwTrafficMeterLan.TrafficMonthlyLimit"] .. "\n") 	

            if (tonumber(tmRow["FwTrafficMeterLan.TimeHH"]) > 12 and tonumber(tmRow["FwTrafficMeterLan.TimeHH"]) < 23) then
                tmRow["FwTrafficMeterLan.spHour"] = tonumber(tmRow["FwTrafficMeterLan.TimeHH"]) - 12
                tmRow["FwTrafficMeterLan.startMeridian"] = "1"
            elseif (tonumber(tmRow["FwTrafficMeterLan.TimeHH"]) == 12) then
                tmRow["FwTrafficMeterLan.spHour"] = tmRow["FwTrafficMeterLan.TimeHH"]
                tmRow["FwTrafficMeterLan.startMeridian"] = "1"
            elseif (tonumber(tmRow["FwTrafficMeterLan.TimeHH"]) == 0) then
                tmRow["FwTrafficMeterLan.spHour"] = "12"
                tmRow["FwTrafficMeterLan.startMeridian"] = "0"
            elseif (tonumber (tmRow["FwTrafficMeterLan.TimeHH"]) > 0 and tonumber (tmRow["FwTrafficMeterLan.TimeHH"]) <= 11) then
                tmRow["FwTrafficMeterLan.spHour"] = tmRow["FwTrafficMeterLan.TimeHH"]
                tmRow["FwTrafficMeterLan.startMeridian"] = "0"
            end
            tmRow["FwTrafficMeterLan.spMinute"] = tmRow["FwTrafficMeterLan.TimeMM"]
            printLabel("Traffic Counter")
            if(tmRow["FwTrafficMeterLan.RestartCounter"] == "1")then
                print("Traffic Counter: Specific Time\n") 		 
            elseif((tmRow["FwTrafficMeterLan.RestartCounter"] == "0")) then 
                print("Traffic Counter: Restart Counter\n") 		 
            end
            if (tmRow["FwTrafficMeterLan.spHour"] ~= nil and tmRow["FwTrafficMeterLan.spMinute"] ~= nil and tmRow["FwTrafficMeterLan.DayOfMonth"] ~= nil) then
                print ("Restart Time (HH/MM-Day of Month): " .. tmRow["FwTrafficMeterLan.spHour"] .. "/" .. tmRow["FwTrafficMeterLan.spMinute"] .. "-" .. tmRow["FwTrafficMeterLan.DayOfMonth"])
            end
            if(tmRow["FwTrafficMeterLan.SendEmailReport"] == "1") then	 
                print("Send e-mail before restarting Counter: Enabled\n")
            elseif (tmRow["FwTrafficMeterLan.SendEmailReport"] == "0") then		 
                print("Send e-mail before restarting Counter: Disabled\n")
            end
            printLabel("When Limit is reached")
            if(tmRow["FwTrafficMeterLan.SendEmailAlert"] == "1") then
                print("Send e-mail alert: Enabled\n")
            elseif (tmRow["FwTrafficMeterLan.SendEmailAlert"] == "0") then
                print("Send e-mail alert: Disabled\n")
            end
    end		 
    tsRow = db.getRow("LanTrafficStatistics", "_ROWID_", args[1])
    if(tsRow ~= nil)then
        printLabel("LAN IP Traffic Statistics")
        resTab.insertField (resultTab, "Start Date / Time", tsRow["LanTrafficStatistics.StartTime"] or "")
        resTab.insertField (resultTab, "Outgoing Traffic Volume", tsRow["LanTrafficStatistics.OutgoingTrafVol"] or "")
        resTab.insertField (resultTab, "Incoming Traffic Volume", tsRow["LanTrafficStatistics.IncomingTrafVol"] or "")
        resTab.insertField (resultTab, "Average per day", tsRow["LanTrafficStatistics.AvgPerDay"] or "")
        resTab.insertField (resultTab, "% of Standard Limit", tsRow["LanTrafficStatistics.StandardLimit"] or "")
        if(tsRow["LanTrafficStatistics.trafficBlocked"] ~= nil and tsRow["LanTrafficStatistics.trafficBlocked"] == "1") then
            trafficBlocked = "Blocked"
        else
            trafficBlocked = "Allowed"
        end
        resTab.insertField (resultTab, "State",trafficBlocked or "")
    end
    resTab.print (resultTab, 0)
end

function trafficMeterLanSetupGet()
    local resultTab = {}
    local i = 0			    
	local table = db.getTable("FwTrafficMeterLan")
    printLabel("LAN Traffic Meter Table")
	for k,v in pairs(table) do
	    i = i + 1
	    local row = table[i]
	    local limitType = ""
	    if(row["FwTrafficMeterLan.TrafficLimitType"] == "1") then
	        limitType = "Download Only"
	    elseif(row["FwTrafficMeterLan.TrafficLimitType"] == "2") then
	        limitType = "Both Directions"
	    end
	    local traffic = "0"			       			       
        local lanTrafficStat = db.getRowsWhere ("LanTrafficStatistics", "LanIP = '" .. row["FwTrafficMeterLan.LanIP"] .."'")			       		       
        if(lanTrafficStat ~= nil) then
            if(lanTrafficStat["LanTrafficStatistics.OutgoingTrafVol"] ~= nil and lanTrafficStat["LanTrafficStatistics.IncomingTrafVol"]) then
               traffic = lanTrafficStat["LanTrafficStatistics.OutgoingTrafVol"] + lanTrafficStat["LanTrafficStatistics.IncomingTrafVol"]
            end
        end
          
        local trafficBlocked = "Allowed"
        if(lanTrafficStat["LanTrafficStatistics.trafficBlocked"] == "1") then
           trafficBlocked = "Blocked"
        else
           trafficBlocked = "Allowed"
        end
                 
        local trafficLimit = '0'
        if(row["FwTrafficMeterLan.TrafficMonthlyLimit"] ~= nil) then
           trafficLimit = row["FwTrafficMeterLan.TrafficMonthlyLimit"]
        end
        resTab.insertField (resultTab, "Row Id", row["FwTrafficMeterLan._ROWID_"] or "")
        resTab.insertField (resultTab, "LAN IP Address", row["FwTrafficMeterLan.LanIP"] or "")
        resTab.insertField (resultTab, "Direction", limitType or "")
        resTab.insertField (resultTab, "Limit (MB)", trafficLimit or "")
        resTab.insertField (resultTab, "Traffic (MB)", traffic or "")
        resTab.insertField (resultTab, "State", trafficBlocked or "")
    end
    resTab.print (resultTab, 0)
end
