/* diagnostics.js - API library for Diagnostics configuration */

/* Copyright 2010-2012 TeamF1, Inc. */

/*
modification history 
------------------------
01d, 10SEP12, Smita modified enableCheck function and added enableThruVpnTunnel function for SPR #33371
01c,27APRIL11,mvb modified error messages and added alphanumeric check in ipaddrValidate1();
01b,28OCT10,mvb modified, added enableCheck function
01a,07OCT10,hb written.
*/


/********************************************************************
* ipaddrValidate : check for ipaddr validate/host name validation 
*
* This function checks ipaddress validation/ host name validation for 
* text box and returns true or flase
*
* RETURNS: true/false
*/ 
function ipaddrValidate ()
    {
    if (txtFieldArrayCheck(["txtIpaddr,Please enter valid IP Address"]) == false) 
        return false; 
    if (checkHostName ('txtIpaddr', true, 'Invalid IP Address/Domain name: ', false) == false) 
        return false; 
    return true;  
    }
    
function ipaddrValidate1()
    {
    var ipAddr = "Please enter valid ip address"
    var ipAddrDmnName = "Invalid IP Address/Domain name"
    var txtValObj = document.getElementById('txtIpaddr').value;    
    if (txtFieldArrayCheck(["txtIpaddr,"+ipAddr]) == false)
        return false;
        
	if (alphaNumericValueCheck ("txtIpaddr", ":.-", "Invalid IP Address/Domain Name: ") == false)
		return false;
	
    if(ipV4FormatCheck(txtValObj) == true)
        {
        if(ipv4Validate("txtIpaddr","IP",false,true,"Invalid IP Address","for octet ",false) == false)
            return false;
        }
    else
        {
        if(checkHostName ('txtIpaddr', true, 'Invalid IP Address/Domain Name: ', false) == false)
            return false;
        }
    return true;
    }

function ipaddrValidate2()
    {
    var ipAddr = "Please enter valid ip address"
    var ipAddrDmnName = "Invalid IPv6 Address/Domain name"
    var txtValObj = document.getElementById('txtIpaddr').value;    
    if (txtFieldArrayCheck(["txtIpaddr,"+ipAddr]) == false)
        return false;
        
    if (alphaNumericValueCheck ("txtIpaddr", ":.-", "Invalid IPv6 Address/Domain Name: ") == false)
        return false;
    
    if(ipv6Validate ('txtIpaddr', true, false, '') == true) return true;
    else if(ipV4FormatCheck(txtValObj) == true)
        {
         alert("Invalid IPv6 Address/Domain Name");
         document.getElementById('txtIpaddr').focus();
         return false;
        }
    else{
        if(checkHostName ('txtIpaddr', true, 'Invalid IPv6 Address/Domain Name: ', false) == false)
            return false;
        }
    return true;
    }
    
/********************************************************************
* diagnosticsValidate : checks the button action 
*
* This function checks button action and return true/false  
*
* RETURNS: true/false
*/ 
function diagnosticsValidate (action)
    {
    if (!action) return false;
    switch (action)
        {
        case 1:  /* ping */
        case 2:  /* trace route */
            if (ipaddrValidate1 () == false)
                return false;
            break;
        case 3:  /* DNS lookup */
        	if(intNameValidate () == false)
                return false;
            break;
        case 4:  /* ping IPv6 */
        case 5:  /* trace route IPv6*/
            if (ipaddrValidate2 () == false)
                return false;
            break;
        default:
            break;
        }
    return true;
    }


function intNameValidate ()
    {
	if (txtFieldArrayCheck(["txtIntName,Please enter valid Internet Name / URL"]) == false) 
		return false; 
	if (checkHostName ('txtIntName', true, 'Invalid Internet Name: ', false) == false) 
		return false; 
 	return true; 
    }

/********************************************************************
* confirmReboot : checks the for reboot confirmation 
*
* This function checks reboot confirmation  
* if true it proceed for reboot else return false
*
* RETURNS: true/false
*/ 
function confirmReboot ()
    {
    var confirmMsg = "Preparing to reboot. Are you sure you want to proceed? WARNING: All current sessions will be closed and the system will be down for about 90 seconds."
    return confirm(confirmMsg);
    }



/********************************************************************
* diagTraceRefresh : it refresh page for every 5 seconds 
*
* This function refresh/reloads the page for every 5 seconds  
*
* RETURNS: N/A
*/
var refreshDelay = 5;    /* seconds */
function diagTraceRefresh ()
    {
    document.frmDiagTrace.submit ();
    }
    
/********************************************************************
* diagTraceInit : setting time for refresh page
*
* This function refresh/reloads the page for every 5 seconds by calling the 
* diagTraceRefresh function
*
* RETURNS: N/A
*/    
function diagTraceInit ()
    {
    setTimeout ("diagTraceRefresh ()", refreshDelay * 1000);
    }


/********************************************************************
* enableCheck : it checks the route mode IPV4/IPV6 or both
*
* This function checks the route mode IPV4/IPV6 or both 
* if only IPV4 then it disables the button IPV6 else it enables the IPV6 display button
*
* RETURNS: N/A
*/    
function enableCheck ()
    {
    var disObj = document.getElementById ('isDisable');
    var bdisObj = document.getElementById('idIpv6Display')
    if(disObj.value == "1")
        {
        fieldStateChangeWr ('idIpv6Display','','','');
        bdisObj.className = "submit_dis submit3 bDisplay"
        }
    enableThruVpnTunnel ();
    }

/********************************************************************
* enableThruVpnTunnel : Enables the dependent fields based on enabling
* or disabling "Ping through VPN tunnel"
*
* This function disables 'Select Local Gateway' and enables 'Select VPN Policy'
* fields when 'Ping through VPN tunnel' is enabled, and vice-versa
*
* RETURNS: True / False
*/
function enableThruVpnTunnel () {
    var chkObj = document.getElementById ('chkPingThruVPNTunl');
    if (chkObj && chkObj.checked) {
        fieldStateChangeWr ('selLocGw','','selVpnPol','');
    }
    else {
        fieldStateChangeWr ('selVpnPol','','selLocGw','');
    }
}
