/* ip_mac_binding.js - API library for IP MAC Binding configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,5OCT10,mvb  written. 
*/

function ipMacBindingValidate ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a IP/MAC Binding Name';
    var errMsgL10n2 = 'Invalid MAC address: Please enter a value in the form XX:XX:XX:XX:XX:XX';
    var errMsgL10n3 = 'Invalid MAC address';
    var errMsgL10n4 = 'Invalid IP address.';
    var errMsgL10n5 = 'for octet';    
     /* L10N Error Message Collection End */
    
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtIpMacName,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtIpMacMacAddr,"+ errMsgL10n2;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    var macObj = document.getElementById('txtIpMacMacAddr');
    if (!macObj || macObj.disabled) return true;
    if (!(macAddrValidate (macObj.value, true, errMsgL10n3+ ":", '')))
        {
        macObj.focus ();
        return false;
        }

	if (ipv4AddrOctetsValidate ('tblIpAddr', 'IP', false, true,
             errMsgL10n4, errMsgL10n5+":", true) == false)
	    return false;
	if(maxCountCheck ('hdCount', 400, 'tblErrMsg') == false)
		return false;    
    return true;
    }
    
function ipMacBindingValidate_IPv6 ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a IP/MAC Binding Name';
    var errMsgL10n2 = 'Invalid MAC address: Please enter a value in the form XX:XX:XX:XX:XX:XX';
    var errMsgL10n3 = 'Invalid MAC address';
    var errMsgL10n4 = 'Invalid IP address.';
    var errMsgL10n5 = 'for octet';    
     /* L10N Error Message Collection End */
    
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtIpMacName_IPv6,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtIpMacMacAddr_IPv6,"+ errMsgL10n2;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    var macObj = document.getElementById('txtIpMacMacAddr_IPv6');
    if (!macObj || macObj.disabled) return true;
    if (!(macAddrValidate (macObj.value, true, errMsgL10n3+ ":", '')))
        {
        macObj.focus ();
        return false;
        }
    
    if (ipv6Validate ('tblIpAddr', false, true, '') == false)
        return false;
        
    if(maxCountCheck ('hdCount', 400, 'tblErrMsg') == false)
       return false;    
    return true;
    }

