/* radvd.js - API library for RADVD configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,12OCT11,mvb  written. 
*/

function checkMTU ()
	{
	var mtuObj = document.getElementById ('txtMTU');
	if (mtuObj.value != "0")
		return numericValueRangeCheck (mtuObj, '', '', 1280, 1500, true, 'MTU must be 0 or between 1280 to 1500:', '');
	else if (mtuObj.value == "0")
		{
		if (document.getElementById ('txtMTUErr'))
			document.getElementById ('txtMTUErr').innerHTML = "";
		}
	return true;
	}
function checkLifetime ()
	{
	var lifetimeObj = document.getElementById ('txtRouterLifetime');
	var advIntObj = document.getElementById ('txtAdvInterval');
	if (numericValueRangeCheck (advIntObj, '', '', 10, 1800, true, '', 'seconds') == false)
		return false;
	if (lifetimeObj.value != "0")
		{
		if (advIntObj.disabled)
			return numericValueRangeCheck (lifetimeObj, '', '', 30, 9000, true, 'Lifetime value should be 0 or between 30 to 9000:', '');
		else
			return numericValueRangeCheck (lifetimeObj, '', '', parseInt (advIntObj.value, 10), 9000, true, 'Lifetime value should be 0 or between ' + advIntObj.value + ' to 9000:', '');
		}
	else if (lifetimeObj.value == "0")
		{
		if (document.getElementById ('txtRouterLifetimeErr'))
			document.getElementById ('txtRouterLifetimeErr').innerHTML = "";
		}
	return true;
	}
function radvdValidate ()
	{
    ipModeObj=document.getElementById ('isDisable');
    if(ipModeObj) ipModeObjVal=ipModeObj.value;
    if(parseInt(ipModeObjVal,10)==1) return false;
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtAdvInterval, Please enter a valid Advertise Interval.";
    txtFieldIdArr[1] = "txtMTU, Please enter a valid MTU.";
    txtFieldIdArr[2] = "txtRouterLifetime, Please enter a valid Router Lifetime.";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
	var myObj = document.getElementById ('txtAdvInterval');
	if (numericValueRangeCheck (myObj, '', '', 10, 1800, true, '', 'seconds') == false)
		return false;
	if (checkMTU () == false)
		return false;
	if (checkLifetime () == false)
		return false;
	return true;
	}
function radvdCheck ()
	{
	var radvdStatus = parseInt (comboSelectedValueGet ('selRadvdStatus'), 10);
	if (radvdStatus == 1)
		{
		fieldStateChangeWr ('', '', 'selAdvtMode txtAdvInterval routerPreference txtMTU txtRouterLifetime selRAflag', '');
		checkMode ();
		}
	else
		fieldStateChangeWr ('selAdvtMode txtAdvInterval routerPreference txtMTU txtRouterLifetime selRAflag', '', '', '');
	}

function enablePrefixAdvTbl ()
	{
	var radvdObj = document.getElementById('radvdStatus');
	if(!radvdObj) return;
	if (radvdObj.value == 1)
		{
		fieldStateChangeWr ('', '', '', 'tblPrefList actionButtnTbl');
		}
	else
		fieldStateChangeWr ('', 'tblPrefList actionButtnTbl', '', '');
	}

function checkMode ()
	{
	var selValue = comboSelectedValueGet ('selAdvtMode');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:
			fieldStateChangeWr ('','','txtAdvInterval','');
			break;
		case 1:
		default:
			fieldStateChangeWr ('txtAdvInterval','','','');
			break;
		}
	}
function enableCheck_radvdDMZ ()
    {
    var disObj = document.getElementById ('isDisable');
    var dmzPortObj = document.getElementById('dmzPort');
    if(disObj.value == "1" || (dmzPortObj && dmzPortObj.value != '' && dmzPortObj.value == 'LAN'))
        fieldStateChangeWr ('','disablePage','','');
    }
