/* resources.js - API library for Resources Validations */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01b,26-APRIL-11,mvb  modified, added maxlimit count check in resourceValidate ();.
01a,7-OCT-10,mvb  written. 
*/

function resourceValidate ()
    {
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtResourceName,Please enter a valid Resource name";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
         return false;

    var unameObj = document.getElementById ('txtResourceName');
    if (unameObj && unameObj.value.indexOf ("+") != -1)
        {
        alert ("\"+\" is not allowed in Resource Name")
 	    return false;
 	    }
   if (unameObj && unameObj.value.indexOf ('"') != -1)
        {
        alert ("Double quote (\") is not allowed in Resource Name")
 	    return false;
 	    }
 	if(maxCountCheck ('hdCount', 32, 'tblErrMsg') == false)
		return false;
		
	return true;
    }


/* edit_resorces.htm */
function resourceValidateEdit ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a valid IP Address / Name';    
    var errMsgL10n2 = 'Invalid IP Address.';    
    var errMsgL10n3 = 'for octet';    
    var errMsgL10n4 = 'Invalid Mask Length: Please enter value between 0 - 31';    
    var errMsgL10n5 = 'Invalid Mask Length';    
    var errMsgL10n6 = 'Invalid Start Port number';
    var errMsgL10n7 = 'Invalid End Port number';
    var errMsgL10n8 = 'Start Port Number should not greater than End Port Number';
    var errMsgObjL10n = document.getElementById ('hd.entrValIpAddrNm');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalIpAddrRes');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.foroctateRes');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalMaskLenBet');
    if (errMsgObjL10n) errMsgL10n4 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalMaskLen');
    if (errMsgObjL10n) errMsgL10n5= errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalStrtPrtNumRes');
    if (errMsgObjL10n) errMsgL10n6= errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalEndPrtNumRes');
    if (errMsgObjL10n) errMsgL10n7= errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.strtPrtGrtrThnEndPrt');
    if (errMsgObjL10n) errMsgL10n8= errMsgObjL10n.value;
    /* L10N Error Message Collection End */

    var txtV4NameObj = document.getElementById('txtIpAddName');
    if(txtV4NameObj && !(txtV4NameObj.disabled))
        {
	    var txtFieldIdArr = new Array ();    
	    txtFieldIdArr[0] = "txtIpAddName,"+ errMsgL10n1;
	    if (txtFieldArrayCheck (txtFieldIdArr) == false)
	         return false;
	         
	    if (alphaNumericValueCheck ("txtIpAddName", ":.", "Invalid IP Address/ Name: ") == false)
			   return false;
	    }

	    
   var txtV6NameObj = document.getElementById('txtIpAddNameV6');
   if(txtV6NameObj && !(txtV6NameObj.disabled))
       {
   var txtFieldIdArray = new Array ();
    txtFieldIdArray[0] = "txtIpAddNameV6,"+ errMsgL10n1;
    if (txtFieldArrayCheck (txtFieldIdArray) == false)
         return false;
         
    if (alphaNumericValueCheck ("txtIpAddNameV6", ":.", "Invalid IP Address/ Name: ") == false)
		   return false;
	   }
    
    if(ipTypeCheck () == false)
        return false;
    
    var strPortObj = document.getElementById('txtStrPort');
    var endPortObj = document.getElementById('txtEndPort');
    
    if (strPortObj.disabled && endPortObj.disabled)
	    return true;
	        
	if (numericValueRangeCheck (strPortObj, 1, "", 1, 65535, true, errMsgL10n6+":", "") == false)
	    return false;
	    	    
	if (numericValueRangeCheck (endPortObj, 1, "",1, 65535, true, errMsgL10n7+":", "") == false)
	        return false;
	        
    if(!isNaN (strPortObj.value) && !isNaN (endPortObj.value) &&
       parseInt (strPortObj.value, 10) > parseInt (endPortObj.value, 10))
		{
		alert (errMsgL10n8);
		strPortObj.focus();
		return false;
	    }

    return true;
    }

function objectTypeCheck ()
	{
	var selectedValue = comboSelectedValueGet  ('selObjectType');
	var ipModeVal = document.getElementById  ('ipModeType').value;
	var radioValue = parseInt (radioCheckedValueGet ('ipv4_ipv6'),10);
	if (!selectedValue) return;
	if (parseInt (selectedValue, 10) == 1)
	    {
	    if(ipModeVal == 3)
	        {
	        if(radioValue == 2)
	            {
	            fieldStateChangeWr ('txtMaxLength tblIPAddV6 tblIPAdd txtIpAddName','','txtIpAddNameV6','');
	            }
	        else
	            {
	            fieldStateChangeWr ('txtMaxLength tblIPAdd txtIpAddNameV6 tblIPAddV6','','txtIpAddName','');
	            }
	        }
	    else
	        {
	        fieldStateChangeWr ('txtMaxLength tblIPAdd txtIpAddNameV6 tblIPAddV6','','txtIpAddName','');
	        }
		}
	else
	    {
	    if(ipModeVal == 3)
	        {
	        if(radioValue == 2)
	            {
	            fieldStateChangeWr ('txtIpAddNameV6 tblIPAdd txtIpAddName','','txtMaxLength tblIPAddV6','');
	            }
	        else
	            {
	            fieldStateChangeWr ('txtIpAddName txtIpAddNameV6 tblIPAddV6','','txtMaxLength tblIPAdd','');
	            }
	        }
	    else
	        {
	        fieldStateChangeWr ('txtIpAddName txtIpAddNameV6 tblIPAddV6','','txtMaxLength tblIPAdd','');
	        }
	    }
	}	
function selIPEnableCheck ()
    {
    var hdIPModeObj = document.getElementById('ipModeType');
    var hdIPModeVal = '';
    if(hdIPModeObj) hdIPModeVal = hdIPModeObj.value;
    if(hdIPModeVal != '' && hdIPModeVal == 3)
        fieldStateChangeWr ('','','ipV6Radio','');
    else
        fieldStateChangeWr ('ipV6Radio','','','');
    }
function getFlagVal()
    {
    var hdIPModeObj = document.getElementById('ipModeType');
    var hdIPModeVal = '';
    var flag = 0;
    if(hdIPModeObj) hdIPModeVal = hdIPModeObj.value;
    var selTypeVal = document.getElementById ('selIPType').value;
    var selectedValue = comboSelectedValueGet  ('selObjectType');
    if(hdIPModeVal != '' && hdIPModeVal == 3)
        {
        if(parseInt (selectedValue, 10) == 1)
            {
            if(parseInt (selTypeVal, 10) == 2)
                flag = 3; //IPv6Addr
            else
                flag = 2; //IPv4Addr
            }
        else
            {
            if(parseInt (selTypeVal, 10) == 2)
                flag = 5; //IPv6Addr
            else
                flag = 6; //IPv4Addr
            }
        }
    else
        {
        if(parseInt (selectedValue, 10) == 1)
            flag = 1; /*IPAddr =  ipv4 validation */
        else
            flag = 4; /*IPNetwork =  ipv4 validation */
        }   
    return flag;    
    }

function ipTypeCheck ()
    {
    var flagg = getFlagVal();
    if(flagg == 3)
        {
        if(ipv6FormatCheck('txtIpAddNameV6') == true)
            {
            if(ipv6Validate ('txtIpAddNameV6', false, true, '') == false)
                return false;
            }
        if (numericValueRangeCheck (document.getElementById('txtMaxLength'), '', 'Invalid Prefix Length: Please enter value between 1 - 128', 1, 128, true, 'Invalid Prefix Length :', '') == false)
	        return false;
        }
    else
        {
        if(flagg == 1 || flagg == 2)
            {
            var txtIPVal = document.getElementById('txtIpAddName').value;
	        if(ipFormatCheck(txtIPVal) == true)
	            {
	            if (ipv4Validate('txtIpAddName', 'IP', false, true, 'Invalid IP address', 'for octet ', true) == false)
	                return false;
	            }
	        }
	    else if(flagg == 5)
	        {
	        if(ipv6Validate ('tblIPAddV6', false, true, '') == false)
                return false;
                
            if (numericValueRangeCheck (document.getElementById('txtMaxLength'), '', 'Invalid Prefix Length: Please enter value between 1 - 128', 1, 128, true, 'Invalid Prefix Length :', '') == false)
	        return false;
	        }
	    else if(flagg == 4 || flagg == 6)
	        {
	        if (ipv4Validate('tblIPAdd', 'SN', false, true, 'Invalid IP address', 'for octet ', true) == false)
	                return false;
                
            obj = document.getElementById('txtMaxLength');
            if (obj && !obj.disabled)
                {
                if (numericValueRangeCheck (obj, 1, 'Invalid Mask Length: Please enter value between 0 - 31', 0, 31, true, 'Invalid Mask Length :', "") == false)
                    return false;
                }
	        }
        }
    return true;
    }

function maskLengthCheckOnTab ()
    {
    var selIPTypeObj = document.getElementById('selIPType');
    var selTypeVal = comboSelectedValueGet ('selIPType');
    var maskLengthObj = document.getElementById('txtMaxLength');
    if(selIPTypeObj && !(selIPTypeObj.disabled) && parseInt(selTypeVal, 10) == 2)
        {
        if (numericValueRangeCheck (maskLengthObj, '', 'Invalid Prefix Length: Please enter value between 1 - 128', 1, 128, true, 'Invalid Prefix Length :', "") == false)
            return false;
        }
    else
        {
        if (numericValueRangeCheck (maskLengthObj, 1, 'Invalid Mask Length: Please enter value between 0 - 31', 0, 31, true, 'Invalid Mask Length :', "") == false)
            return false;
        }
    return true;
    }
    
/****************************************************************************
Function: toggleWrapper
Purpose: wrapper function, calls other inter related function also
params : N/A
Returns: N/A
*/

function toggleWrapper ()
    {
    var radioValue = radioCheckedValueGet ('ipv4_ipv6');
    var addressFamilyObj = document.getElementById ('selIPType');    
    var trObjIPv4 = document.getElementById('tblBrowserListIPv4');
    var trObjIPv6 = document.getElementById('tblBrowserListIPv6');
    var tdObjLabel = document.getElementById('tdLabel');
    if( addressFamilyObj )
        {        
        addressFamilyObj.value = radioValue;
        if (radioValue == "2")
            {            
            toggle ('trIpAddressV4 trIpAddressNetV4', '', '', 'trIpAddressV6 trIpAddressNetV6', 'txtIpAddName tblIPAdd', 'trIpAddressV4 trIpAddressNetV4 tblBrowserListIPv4', 'txtIpAddNameV6 tblIPAddV6', 'trIpAddressV6 trIpAddressNetV6 tblBrowserListIPv6');
            if(tdObjLabel)
                document.getElementById('tdLabel').innerHTML = 'Prefix Length';
            if(trObjIPv4)
                document.getElementById('tblBrowserListIPv4').className = "hide";
            if(trObjIPv6)
                document.getElementById('tblBrowserListIPv6').className = "show";
            }
        else
            {
            toggle ('', 'trIpAddressV6 trIpAddressNetV6', 'trIpAddressV4 trIpAddressNetV4', '', 'txtIpAddNameV6 tblIPAddV6', 'trIpAddressV6 trIpAddressNetV6 tblBrowserListIPv6', 'txtIpAddName tblIPAdd', 'trIpAddressV4 trIpAddressNetV4 tblBrowserListIPv4');
            if(tdObjLabel)
                document.getElementById('tdLabel').innerHTML = 'Mask Length';
            if(trObjIPv4)
                document.getElementById('tblBrowserListIPv4').className = "show";
            if(trObjIPv6)
                document.getElementById('tblBrowserListIPv6').className = "hide";
            }
        }
        selIPEnableCheck ();
        objectTypeCheck ();     
    }
