/*
Copyright (c) 2010 TeamF1, Inc.
All rights reserved.
*/

function pageValidate ()
    {
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtRouteName,Please enter the RouteName";    
    txtFieldIdArr[1] = "txtDestIpAddr,Please enter the Destination IP Address";
    txtFieldIdArr[2] = "txtPreLen,Please enter the Prefix Length";    
    txtFieldIdArr[3] = "txtGwIpAddr,Please enter the Gateway IP Address";    
    txtFieldIdArr[4] = "txtMetric,Please enter the Metric";
    if(isProblemCharArrayCheck(txtFieldIdArr)==false){
        return false;
    }
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    if (ipv6Validate ('txtDestIpAddr', true, true, '') == false)
        return false;

    var preLenObj = document.getElementById ('txtPreLen');
    if (numericValueRangeCheck (preLenObj, '', '', 0, 128, true, '', '') == false)
        return false;

    if (ipv6Validate ('txtGwIpAddr', true, true, '') == false)
        return false;
        
    var metricObj = document.getElementById ('txtMetric');
    if (numericValueRangeCheck (metricObj, '', '', 2, 15, true, '', ' ') == false)
        return false;

    var setIp = "";
    var setPrefix = "";
    var selectedInt = document.getElementById ('selInterface').value;
    if (selectedInt == "sit0-WAN1")
        {
        return isGatewayInTunnelSubnet ('hdTunnelv6IPAddr', 'hdWanSnetAddr', 'txtGwIpAddr', 'Enter IP in the same subnet as the interface');
        }
    else if (selectedInt == "LAN")
        {
        return checkInterfaceGatewaySubnet ('hdLanv6IPAddr','hdLanv6Prefix', 'txtGwIpAddr', 'Enter IP in the same subnet as the interface');
        }
    else if (selectedInt == "WAN1")
        {
        return checkInterfaceGatewaySubnet ('hdWanv6IPAddr','hdWanv6Prefix', 'txtGwIpAddr', 'Enter IP in the same subnet as the interface');
        }
    else if (selectedInt == "WAN2")
        {
        return checkInterfaceGatewaySubnet ('hdWan2v6IPAddr','hdWan2v6Prefix', 'txtGwIpAddr', 'Enter IP in the same subnet as the interface');
        }
    else if (selectedInt == "WAN3")
        {        
        return checkInterfaceGatewaySubnet ('hdWan3v6IPAddr', 'hdWan3v6Prefix','txtGwIpAddr', 'Enter IP in the same subnet as the interface');
        }
    else if (selectedInt == "WAN4")
        {
        return checkInterfaceGatewaySubnet ('hdWan4v6IPAddr', 'hdWan4v6Prefix', 'txtGwIpAddr', 'Enter IP in the same subnet as the interface');
        }         
    return true;
    }

/*************************************************************************************
function:checkInterfaceGatewaySubnet
purpose:checks if the subnet of gateway and selected interface falls in the same subnet
params:
      1 - strString:prefix id of one of the IPs
      2 - prefixStr:prefix id for prefix
      3 - gateway id
      4 - message:message to be shown
*/
function checkInterfaceGatewaySubnet (strString, prefixStr, gatewayId, message){
    var cnt=1;
    while(document.getElementById(strString + cnt)) {
        setIp = strString+cnt;
        setPrefix = prefixStr+cnt;
        if(ipv6SubnetValidation1(setIp,setPrefix,gatewayId) == true) {
            return true;
        }
    cnt++;
    }
    alert (message);
    return false;
}

function isGatewayInTunnelSubnet (ipAddrPrefix, subnetId, gatewayId, msg) {
    var cnt = 1;
    var gwAddrObj = document.getElementById (gatewayId);
    var gwAddrVal = gwAddrObj.value;
    var gwAddrArray = gwAddrVal.split ("::");
    var gwAddrObjVal;
    if (gwAddrArray.length != 2) {
        alert (msg);
        return false
    }
    else {
        gwAddrObjVal = gwAddrArray[1];
        if (gwAddrObjVal == "") {
            alert (msg);
            return false;
        }
        else {
            var gwIp = getIPInt2 (gwAddrObjVal);
            var intIpMask = getIPInt1 (subnetId);
            if (ipAddrValueFormatCheck (gwAddrObjVal) == false) {
                alert (msg);
                return false;
            }
            else {
                    var flag = 0;
                    while (document.getElementById (ipAddrPrefix + cnt)) {
                    var ipAddrObj = document.getElementById (ipAddrPrefix + cnt);
                    var ipAddrVal = ipAddrObj.value;
                    var ipAddrArray = ipAddrVal.split ("::");
                    var ipAddrObjVal = ipAddrArray[1];
                    if (ipAddrObjVal == "127.0.0.1" || ipAddrObjVal == "") {}
                    else {flag = 1;}
                    cnt++;
                }
                if (flag == 0) {
                    alert (msg);
                    return false;
                }
            }
        }
    }
    return true;
}
