/* tr069.js - API library for Tr069 configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,12OCT10,hb written.
*/

function checkTR069Enable ()
	{
	var selValue = radioCheckedValueGet ('tr069Config.enableTR069');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* NO */
			fieldStateChangeWr ('txtPort1 txtPort2 txtAcsUsername txtAcsPwd txtConnUsername txtConnPwd txtUrl rdbStunYes rdbStunNo txtUsrName txtPwd','tblSvrIPAddr','','');
			break;
		case 1:	/* YES */
			fieldStateChangeWr ('','','txtPort1 txtPort2 txtAcsUsername txtAcsPwd txtConnUsername txtConnPwd txtUrl rdbStunYes rdbStunNo txtUsrName txtPwd','tblSvrIPAddr');
			checkStunEnable ();
			break;
		}
	}
function checkStunEnable ()
	{
	var selValue = radioCheckedValueGet ('tr069Config.isStunEnable');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* NO */
			fieldStateChangeWr ('txtUsrName txtPwd','tblSvrIPAddr','','');
			break;
		case 1:	/* YES */
			fieldStateChangeWr ('','','txtUsrName txtPwd','tblSvrIPAddr');
			break;
		}
	}
function tr069ConfigValidation ()
	{
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtPort1,Please enter a valid TR-069 Port1 value";
    txtFieldIdArr[1] = "txtPort2,Please enter a valid TR-069 Port2 value";
    txtFieldIdArr[2] = "txtAcsUsername,Please enter a valid ACS username";
    txtFieldIdArr[3] = "txtAcsPwd,Please enter a valid ACS password";
    txtFieldIdArr[4] = "txtConnUsername,Please enter a valid connection request username";
    txtFieldIdArr[5] = "txtConnPwd,Please enter a valid connection request password";
    txtFieldIdArr[6] = "txtUrl,Please enter a valid TR-069 URL";
    txtFieldIdArr[7] = "txtUsrName,Please enter a valid STUN username";
    txtFieldIdArr[8] = "txtPwd,Please enter a valid STUN password";

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    var txtFieldIdArray = new Array ();    
    txtFieldIdArray[0] = "txtAcsUsername,Please enter a valid ACS username";
    txtFieldIdArray[1] = "txtAcsPwd,Please enter a valid ACS password";
    txtFieldIdArray[2] = "txtConnUsername,Please enter a valid connection request username";
    txtFieldIdArray[3] = "txtConnPwd,Please enter a valid connection request password";
    txtFieldIdArray[4] = "txtUsrName,Please enter a valid STUN username";
    txtFieldIdArray[5] = "txtPwd,Please enter a valid STUN password";
        
    if(isProblemCharArrayCheck (txtFieldIdArray) == false)
        return false;
        
    var portObj = document.getElementById('txtPort1');
    if (portObj && !portObj.disabled &&
        portValueRangeCheck (portObj, 1025, 65535, 1024, null, true, 'Invalid TR-069 Port1.') == false)
        return false;
        
    portObj = document.getElementById('txtPort2');
    if (portObj && !portObj.disabled &&
        portValueRangeCheck (portObj, 1025, 65535, 1024, null, true, 'Invalid TR-069 Port2.') == false)
        return false;
        
    if (ipv4AddrOctetsValidate ('tblSvrIPAddr', 'IP', false, true,
             "Invalid STUN Server IP Address.", "for octet ", true) == false)
        return false;
        
    return true;
	}

